#include "uart0.h"
#include "System/lpc214x.h"	// PCLK
#include <stdlib.h>

//initializes both uart0 and uart1
char uart0Init (unsigned long baudRate)
{
	// TODO 1.  Initialize UART with the given baud rate
	// Note: PCLK is already defined
	PINSEL0 &= ~(3 << 0); //clears the 2 LSB for uart0
	PINSEL0 |= (1 << 0);  //sets the 2 LSB for uart0

	PINSEL0 &= ~(3 << 2);  //clears bits 2 and 3 for uart0 RX
	PINSEL0 |= (1 << 2);  //sets bits 2 and 3 uart0 RX

	U0LCR = 0x83;
	U0DLL = PCLK / (16 * baudRate);
	U0DLM = 0;
	U0LCR &= ~(1 <<7);

	//UART1 REGISTER INITIALIZATION
//	U1LCR = 0x83;
//	U1DLL = PCLK / (16 * baudrate);
//	U1DLL = 0;
//	U1LCR &= ~(1 <<7);

//	PINSEL0 &= ~(0xC0000 << 0); //clears bits 19 and 18 for UART1
//	PINSEL0 &= ~(3 << 18);		same as above line
//	PINSEL0 |= (0x40000 << 1); //sets the 18th bit to 1 for UART1 RX
//  PINSEL0 |= (1 << 18);		//same as above line




/*
		PINSEL0 &= 0xfffffff0;	// Clear configuration of P0.0 and P0.1
		PINSEL0 |= 0x00000005;	// Enable RxD0 and TxD0
		U0LCR = 0x83;			// 8 bits, no Parity, 1 Stop bit

		U0DLL = PCLK / (16 * baudRate);
		U0DLM = 0;
		U0LCR &= ~(1 <<7);			// DLAB = 0*/
	return 1;
}

unsigned long uart0GetChar (char *pcRxedChar, portTickType xBlockTime)
{
	// TODO 2.  Wait until UART captures a char, and store it to pcRxedChar
	// Ignore the Block time variable
	while (1)
	{
		if(U0LSR & ( 1 << 0))
		{
			break;
		}
	}
	*pcRxedChar = U0RBR;
	return 1;
}

unsigned long uart0PutChar (char cOutChar, portTickType xBlockTime)
{
	// TODO 3.  Send a char out the UART
	// Ignore the Block time variable
	while(1)
	{
		if(U0LSR & (1 << 5))
		{
			break;
		}
	}
	U0THR = cOutChar;
	return 1;
}
